
'-- NOTES:  This script uses jsShell, which uses Active Accessibility, to find the homepage URL in Internet Explorer.
' To run the demo, first open IE and click Menu -> Tools -> Internet Options
' Make sure the General tab is showing and then run the script.
'
' The script finds the IE homepage URL by first enumerating top-level open windows to
' find the Internet Options window. It gets that window as an AAWindow. The current 
' tab is actually a sub-window, so the textbox holding the homepage URL will not be found
' in the window object. It's required that the tabwindow handle be retrieved, allowing the
' tabwindow to then be retrieved as an AAWindow object. It's then possible to enumerate
' the items in that AAWindow and find the textbox.

' If you open a tab other than General and then run the script it will tell you the wrong
' tab is open, and will tell you which tab is selected. It does that by checking the 
' Caption property of the tab's AAWindow object.

Dim jsS, jsSWins, i2, i3, iCount, A1, sTitle, H1, HTab, sList, sHomePage, Ret
Dim jsSAAWin, jsSAAWin2, sCaption, TitleToFind

Ret = MsgBox("For this demo you must have Internet Explorer open, then open Internet Options to the General tab. Ready?", 33, "Find IE Homepage URL")
  If Ret = 2 Then WScript.quit
  
Set jsS = CreateObject("jsShell.Ops")
 Set jsSWins = jsS.GetOpenWindows
TitleToFind = "Internet Options"

i2 = jsSWins.GetOpenWindowTitles(A1)
  If i2 > 0 Then
    For i3 = 0 to i2 - 1
        sTitle = A1(i3)
        If InStr(1, sTitle, TitleToFind, 1) > 0 Then Exit For
    Next
  End If
  
 If InStr(1, sTitle, TitleToFind, 1) = 0 Then MsgBox "Internet Options window not found.", 64 :  DropIt '--window not found.
  
H1 = jsSWins.GetWindowHandleFromTitle(sTitle) '-- get IE Options window handle.

Set jsSAAWin = jsS.GetAAWindowByHandle(H1) '-- get data from iaccessible pointer.

iCount = jsSAAWin.ItemCount  'window object count

For i2 = 0 to iCount - 1   ' enumerate objects in window. Need to find the tabwindow and then enumerate that.

  '-- uncomment this to see a list of objects found in the top-level window.
  '  sList = sList & jsS.GetAAObjectNameFromObjectID(jsSAAWin.Item(i2).ObjectID) & vbCrLf  '-- <<<extra demo commented out>>>
   
  If jsSAAWin.Item(i2).ObjectID = 38 Then   '-- when a tabwindow is found in window, get it as a window.
       HTab = jsSAAWin.Item(i2).Handle     
       Exit For
   End If
 Next   

 '-- uncomment this, along with line above, to see list of window objects.
 ' MsgBox sList                                                                                                                      '-- <<<extra demo commented out>>>

  If HTab = 0 Then MsgBox "Tab window not found.", 64 : DropIt
  
  Set jsSAAWin2 = jsS.GetAAWindowByHandle(HTab)
    sCaption = jsSAAWin2.Caption
      If sCaption <> "General" Then MsgBox "The wrong tab is open. The " & sCaption & " tab is open instead of the General tab.", 64 : DropIt
    
       iCount = jsSAAWin2.ItemCount  'window object count
       sList = ""
    For i2 = 0 to iCount - 1
  
    '-- uncomment this to see a list of objects found in the top-level window.
    '  sList = sList & jsS.GetAAObjectNameFromObjectID(jsSAAWin2.Item(i2).ObjectID) & vbCrLf  '-- <<<extra demo commented out>>>
   
        If jsSAAWin2.Item(i2).ObjectID = 42 Then 
            sHomePage = jsSAAWin2.Item(i2).Value
            Exit For
        End If
    Next    
    
   '-- uncomment this, along with line above, to see list of window objects.
 ' MsgBox sList                                                                                                                      '-- <<<extra demo commented out>>>
    
If Len(sHomePage) > 0 Then
   MsgBox "IE Homepage URL: " & vbCrLf & sHomePage
Else
   MsgBox "IE Homepage not found."
End If     

DropIt

Sub DropIt()
  Set jsSAAWin2 = Nothing
  Set jsSAAWin = Nothing
  Set jsSWins = Nothing
  Set jsS = Nothing
  WScript.Quit
End Sub  