'-- jsShell demo script. This script demonstrates using the jsShell events to
'-- speak a description of current activity. This script is the same as
'-- the other event demo except that it reads screen coordinates and parent window handle for objects.
'-- it also includes code to use GetAAObjectByHandle and then calls DoDefaultAction on that AAObject.
'-- The DoDefaultAction demo auto-clicks any button in an open window with the caption "No".
'-- To see that demo, run the BasicYesNo.vbs script before running this script and leave the message window open.

'SVSFlagsAsync Or SVSFPurgeBeforeSpeak Or SVSFIsNotXML = 19
Dim jsS, AAOb, AAWin, Voice, iNow, iNow2, sNow, A1, BooRun, BooEvents
Set jsS = WScript.CreateObject("jsShell.Ops", "AA_")
Set Voice = CreateObject("Sapi.spVoice")
iNow = GetNow
BooRun = True
BooEvents = True

jsS.AAHookEventsStart

Do While BooRun = True
  WScript.sleep 10
  iNow2 = GetNow
  If (iNow2 > iNow + 1) Or (iNow2 = 0) Then BooRun = False   'go for about 2-3 minutes.
Loop

MsgBox "done"
WScript.DisconnectObject jsS
  jsS.AAHookEventsStop
  Set jsS = Nothing
  Set Voice = Nothing
  WScript.Quit


Sub AA_AAEvent(EventCode, EvHandle, EvValid, EvObjectName, EvObjectID, EvCaption, EvValue, EvSelected, EvHasFocus, EvDisabled, EvChecked)
   Dim sWords
   If EvValid = True Then 
     Select Case EventCode
       Case 3 ' window focus change
         If (EvObjectID = 9) Or (EvObjectID = 37) Then
            jsS.AAHookEventsStop
            ReadWindow 3
            Exit Sub
         End If   
           '--- textbox ops: combined with the keystroke event, the result is that a small amount of text
           '-- in a textbox will be read in its entirety. If there are more than 50 characters then each
           '-- letter will be read as it's typed instead.
       Case 32782 ' &H800E - valuechanged
          If EvObjectID = 42 Then 'textbox  
             If Len(EvValue) < 50 Then sWords = EvValue  '-- if message is change of content in a text box then read the new content.
           Else
             If EvObjectID <> 3 Then sWords =  EvObjectName & " " & EvCaption 
          End If
       Case Else
          Select Case EvObjectID
             Case 3 'scrollbar 
               'nothing
             Case Else  
                sWords =  EvObjectName & " " & EvCaption 
          End Select      
     End Select    
        If Len(sWords) > 0 Then SayIt sWords      
   End If      
End Sub

Sub AA_Keystroke(sKeyChar)
   SayIt sKeyChar
End Sub
'-- with change in focus, suspend events while reading new titlenbar text. If it's a msgbox, also read caption and buttons.
'-- When done, reset BooEvents variable to go back to reading events.
Sub ReadWindow(iType)
   Dim H1, H2, sWords, iEl, iCount, LRet
   H1 = jsS.GetActiveWindowHandle
   Set AAWin = jsS.GetAAWindowByHandle(H1)
     If AAWin.IsValid Then
         sWords =  "Window focus changed. " 
           If Len(AAWin.Caption) > 0 Then sWords = sWords & "Window title: " & AAWin.Caption
         
         iCount = AAWin.ItemCount
           If iCount > 0 Then  
                For iEl = 0 to iCount - 1 
                  Set AAOb = AAWin.Item(iEl)
                   Select Case AAOb.ObjectID
                      Case 33, 34, 41, 42, 43, 44, 45, 46 ' listbox, list item, window text, textbox, button, checkbox, option, combobox
                           sWords = sWords & AAOb.ObjectName & " " & AAOb.Caption & ": "
                        If AAOb.ObjectID = 44 Or AAOb.ObjectID = 45 Then
                           sWords = sWords & "checked " & AAOb.Checked
                        End If
                          sWords = sWords & "Top " & AAOb.PixTop & ": Left " & AAOb.PixLeft & ": Width " & AAOb.PixWide & ": Height " & AAOb.PixHigh & " Parent window handle: " & AAOb.ParentWindowHandle
                         If Len(sWords) > 0 Then SayIt sWords
              If AAOb.ObjectName = "button" And AAOb.Caption = "No" Then
                 Dim AAOb2
                      Set AAOb2 = jsS.GetAAObjectByHandle(AAOb.Handle)
                         LRet = AAOb2.DoDefaultAction(0)
                         MsgBox "Default action. Clicked No button."
                      Set AAOb2 = Nothing
               End If       
                    Case Else
                   End Select
                 Set AAOb = Nothing
               Next
           End If    
      End If
   Set AAWin = Nothing  
   
  jsS.AAHookEventsStart
End Sub

Sub SayIt(s)
  Voice.Speak s, 19
End Sub

Function GetNow()
  Dim sNow, A1
  sNow = Now
 A1 = Split(sNow, " ")
 sNow = A1(1)
 A1 = Split(sNow, ":")
 GetNow = CLng(A1(1))
End Function

Sub DropIt()
  WScript.DisconnectObject jsS
  jsS.AAHookEventsStop
  Set jsS = Nothing
  Set Voice = Nothing
  WScript.Quit
End Sub  