'-- This script demonstrates the Windows object and ChildWindows object in jsShell.
'-- It also demonstrates getting a document object from IE. In this case IE has tabs.
'-- This demo requires IE open, with tabs enabled, several pages loaded, and one
'-- of those pages must be named "test4.html". The script will find IE, then find
'-- the parent window of the tab with test4.html loaded, then access that document object.

'-- When IE runs with tabs there is a separate browser window for each page loaded.
'-- In normal IE the loaded webpage URL is part of the main window title bar. In IE
'-- with tabs, each loaded page results in a minor window hierarchy of it's own.
'-- Each page has a top-level child window of class name "Frame Tab". Under that are
'-- a number of windows. A window with the class name "TabWindowClass" is the top-level
'-- child container for the browser window for that particular webpage. The "TabWindowClass"
'-- window has title text with the webpage URL. 

'-- What does all that mean? If you have 3 webpages open in tabs in IE, there will be
'-- 3 child windows of type "Frame Tab", and each of those will have a child window 
'-- of type  "TabWindowClass". If you want to get hold of the document object for a
'-- specific tab you need to find the child window with the URL of interest, then call
'-- GetIEDocFromHandle on that window handle. If you call GetIEDocFromHandle with the
'-- IE window handle, as one would do in a no-tabs scenario, then the document you get 
'-- cannot be controlled. It will probably be the first tab's document.

Dim jsS, jsSWins, CW, iCount, i2, sList, i3, HIETop, HIE, IEDoc, Boo1, sWin, sTitle, H1, sCls
  Set jsS = CreateObject("jsShell.Ops")
  
  Set jsSWins = jsS.GetOpenWindows

  
iCount = jsSWins.WindowCount

MsgBox "Window count: " & iCount

HIE = 0
For i2 = 1 to iCount
  sWin = jsSWins.GetWindowTitleByIndex(i2)
    If InStr(1, sWin, "internet", 1) > 0 Then 
        HIETop = jsSWins.GetWindowHandleByIndex(i2)
        Exit For
    End If
 Next

If HIETop = 0 Then
  MsgBox "IE needs to be open with tabs for this demo.", 64
  DropIt
End If

 Set  CW = jsSWins.GetChildWindows(HIETop, True, i2) 
     If i2 = 0 Then DropIt '--should never happen. IE always has child windows.
     HIE = 0
     sList = "IE tabs:" & vbCrLf & vbCrLf
   For i3 = 1 to i2
     sTitle = CW.GetWindowTitleByIndex(i3) 'get title
     H1 = CW.GetWindowHandleByIndex(i3)  'get handle
     sCls = CW.GetWindowClassNameFromHandle(H1)  ' get class name
         If sCls = "TabWindowClass" Then sList = sList & sTitle & vbCrLf '-- this class name indicates the window is the tab parent window with the URL in the title.
      If InStr(1, sTitle, "test4.html", 1) > 0 Then  '--this is the parent tab for this loaded webpage.  
          HIE = H1
         ' Exit For  '--commented this out to demonstrate getting all URLs for all loaded tabs.
      End If
    Next
    
MsgBox sList '-- show list of loaded webpages.

If HIE = 0 Then
   MsgBox "This demo requires IE open with tabs, and a page loaded named 'test4.html'. To finish the demo either load such a file or edit the script, then re-run the script.", 64
   DropIt
End If

  Set IEDoc = jsSWins.GetIEDocFromHandle(HIE, Boo1)
      If Boo1 = True Then
          IEDoc.write "jsShell-derived IE Doc writing to IE document."
      Else
         MsgBox "Failed to get a document object from IE instance."
     End If         


 'SetWindowActive returns:  0-ok. 1-already active. 2-window handle invalid.
  '-- 3- op failed. 5-error.
  
i2 = jsSWins.SetWindowActive(HIETop, True)
  If i2 <> 0 Then MsgBox "SetWindowActive failed. Error: " & CStr(i2)

Sub DropIt()
  Set IEDoc = Nothing
  Set CW = Nothing
  Set jsSWins = Nothing
  Set jsS = Nothing
  WScript.quit
End Sub
   