'-- This script demonstrates the Windows object in jsShell.
'-- Windows represents open top-level windows. A ChildWindows object, representing the 
'-- windows below a given window, is also available from the handle (hWnd) of a top-level window.

Dim jsS, jsSWins, jsSChildWins, iCount, i2, sList, A1, i3, H3, T3, HIE, IEDoc, Boo1
  Set jsS = CreateObject("jsShell.Ops")
  
  Set jsSWins = jsS.GetOpenWindows

  
iCount = jsSWins.WindowCount

MsgBox "Window count: " & iCount

i2 = jsSWins.GetOpenWindowTitles(A1)
  If i2 > 0 Then
    For i3 = 0 to i2 - 1
        sList = sList & A1(i3) & vbCrLf
    Next
      MsgBox i2 & " windows: " & vbCrLf & sList
  Else
     MsgBox "Error: GetOpenWindowTitles failed."
  End If
  
'-- these do not always return values in this script due to the fact that the script message boxes change the active window.

MsgBox "Active window handle: " & jsSWins.GetActiveWindowHandle

MsgBox "Active window title: " & jsSWins.GetActiveWindowTitle

H3 = jsSWins.GetWindowHandleByIndex(3)
MsgBox "Handle of third window: " & H3

T3 = jsSWins.GetWindowTitleByIndex(3)
MsgBox "Title of third window: " & T3

MsgBox "GetWindowTitleFromHandle called for handle of third window: " & vbCrLf & jsSWins.GetWindowTitleFromHandle(H3)

 '-- note: this assumes window title is at least 8 characters....usually safe.
MsgBox "GetWindowHandleFromTitle called for part of title of third window: " & vbCrLf & jsSWins.GetWindowHandleFromTitle(right(T3, 8))

MsgBox "Window PID for window number 3: " & jsSWins.GetWindowPID(H3)

MsgBox "IE needs to be open for the next part of this demo, and it needs to be the only window open that has 'internet' in its title bar text. Click OK when ready."

jsSWins.Refresh

HIE = jsSWins.GetWindowHandleFromTitle("internet")
If HIE = 0 Then 
    MsgBox "Failed to get IE window handle."
Else
   Set  jsSChildWins = jsSWins.GetChildWindows(HIE, False, i2) 
   MsgBox "Child window count: " & i2
   sList = "Child window titles and classes:" & vbCrLf & vbCrLf
   If i2 > 0 Then
     For i3 = 1 to i2
         sList = sList & "  " & i3 & ") " & "Title: " & jsSChildWins.GetWindowTitleByIndex(i3) & " Class: " & jsSChildWins.GetWindowClassNameFromHandle(jsSChildWins.GetWindowHandleByIndex(i3))
     Next  
      MsgBox sList
  End If   
End If

If HIE > 0 Then
    Set IEDoc = jsSWins.GetIEDocFromHandle(HIE, Boo1)
      If Boo1 = True Then
          IEDoc.write "jsShell-derived IE Doc writing to IE document."
      Else
         MsgBox "Failed to get a document object from IE instance."
     End If         
End If     

 'SetWindowActive returns:  0-ok. 1-already active. 2-window handle invalid.
  '-- 3- op failed. 5-error.
  
i2 = jsSWins.SetWindowActive(HIE, True)
  If i2 <> 0 Then MsgBox "SetWindowActive failed. Error: " & CStr(i2)

Set IEDoc = Nothing
Set jsSChildWins = Nothing
Set jsSWins = Nothing
   Set jsS = Nothing